package weaverjn.action.common;

package ..deTemp.1732155631795;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.hrm.company.DepartmentComInfo;
import weaver.hrm.resource.ResourceComInfo;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.Log;
import weaver.soa.workflow.request.RequestInfo;
import weaver.soa.workflow.request.RequestLog;
import weaver.workflow.request.RequestManager;
import weaverjn.yksap.si_result_out_syn.MT_RESULT_REQ;
import weaverjn.yksap.si_result_out_syn.MT_RESULT_RSP;
import weaverjn.yksap.si_result_out_syn.REQUEST_INFO;
import weaverjn.yksap.si_result_out_syn.REQUEST_LOG;
import weaverjn.yksap.si_result_out_syn.SubmitRequest;

public class ActionFsCommon extends BaseBean implements Action {
  private String IFYWID;
  
  public String execute(RequestInfo requestInfo) {
    String requestid = requestInfo.getRequestid();
    apilog(requestid, "开始执行接口");
    RequestManager rm = requestInfo.getRequestManager();
    writeLog(rm.getSrc());
    String tablename = rm.getBillTableName();
    RecordSet rs = new RecordSet();
    String sql = "select * from " + tablename + " where requestid=" + requestid;
    writeLog(sql);
    rs.execute(sql);
    rs.next();
    String ZSQDH = Util.null2String(rs.getString("ZSQDH"));
    String MANDT = Util.null2String(rs.getString("MANDT"));
    Map<String, String> ZFILED = new HashMap<>();
    ZFILED.put("ZFILED2", "SQYW");
    ZFILED.put("ZFILED5", MANDT);
    MT_RESULT_RSP mt_result_rsp = callAction(requestInfo, Util.null2String(this.IFYWID), "", ZSQDH, "", ZFILED);
    if (mt_result_rsp == null) {
      rm.setMessageid(requestid);
      rm.setMessagecontent("PO接口异常！");
      return "0";
    } 
    String ZTYPE = mt_result_rsp.getZTYPE();
    String ZMESSAGE = mt_result_rsp.getZMESSAGE();
    apilog(requestid, "接口执行完毕：" + ZTYPE + "," + ZMESSAGE);
    if (!"S".equals(ZTYPE)) {
      rm.setMessageid(requestid);
      rm.setMessagecontent("PO接口报错：" + ZMESSAGE);
      return "0";
    } 
    return "1";
  }
  
  private void apilog(String requestid, String string) {
    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSS");
    Date date = new Date();
    RecordSet rs = new RecordSet();
    String field = "";
    String value = "";
    field = field + "jk,";
    value = value + "'" + getClass().getName() + "',";
    field = field + "sj,";
    value = value + "'" + sdf.format(date) + "',";
    field = field + "lc,";
    value = value + "'" + requestid + "',";
    field = field + "rz";
    value = value + "'" + string + "'";
    String sql = "insert into uf_jkrzjk(" + field + ")values(" + value + ")";
    writeLog(sql);
    rs.execute(sql);
  }
  
  public MT_RESULT_RSP callAction(RequestInfo requestInfo, String IFYWID, String ZDATA, String BSKEY, String SAPKEY, Map<String, String> ZFIELD) {
    String status;
    writeLog("run");
    MT_RESULT_REQ req = new MT_RESULT_REQ();
    req.setSYSID("OA");
    req.setIFYWID(IFYWID);
    req.setBSKEY(BSKEY);
    req.setSAPKEY(SAPKEY);
    req.setBSKEY(BSKEY);
    req.setZDATA(ZDATA);
    if (ZFIELD != null)
      for (Map.Entry<String, String> entry : ZFIELD.entrySet()) {
        String key = entry.getKey();
        String value = entry.getValue();
        if (key.equalsIgnoreCase("ZFILED1")) {
          req.setZFILED1(value);
          continue;
        } 
        if (key.equalsIgnoreCase("ZFILED2")) {
          req.setZFILED2(value);
          continue;
        } 
        if (key.equalsIgnoreCase("ZFILED3")) {
          req.setZFILED3(value);
          continue;
        } 
        if (key.equalsIgnoreCase("ZFILED4")) {
          req.setZFILED4(value);
          continue;
        } 
        if (key.equalsIgnoreCase("ZFILED5")) {
          req.setZFILED5(value);
          continue;
        } 
        if (key.equalsIgnoreCase("ZORG"))
          req.setZORG(value); 
      }  
    REQUEST_INFO request_info = new REQUEST_INFO();
    request_info.setZWFID(requestInfo.getWorkflowid());
    request_info.setZWFSNO(requestInfo.getRequestid());
    RequestManager requestManager = requestInfo.getRequestManager();
    if (requestManager.getSrc().equals("submit")) {
      status = "03";
    } else if (requestManager.getSrc().equals("reject")) {
      status = "04";
    } else {
      status = "03";
    } 
    request_info.setZWFSTU(status);
    String remark = requestManager.getRemark();
    if (remark.contains("remark") && remark.contains("remarkquote"))
      remark = ""; 
    request_info.setZWFTXT(Util.delHtmlWithSpace(Util.null2String(remark)).replaceAll("&dt;", "").replaceAll("&at;", ""));
    req.setREQUEST_INFO(request_info);
    ResourceComInfo resourceComInfo = null;
    DepartmentComInfo departmentComInfo = new DepartmentComInfo();
    try {
      resourceComInfo = new ResourceComInfo();
    } catch (Exception e) {
      e.printStackTrace();
    } 
    writeLog("resourceComInfo" + resourceComInfo);
    List<REQUEST_LOG> request_logs = new ArrayList<>();
    RequestLog requestLog = requestInfo.getRequestLog();
    Log[] logs = requestLog.getLog();
    RecordSet rs = new RecordSet();
    for (Log log : logs) {
      String ZNODID = log.getNodeid();
      writeLog(ZNODID);
      String ZNODTX = log.getNode();
      String ZWFSTU = log.getOptype();
      if (ZWFSTU.equals("3")) {
        ZWFSTU = "04";
      } else {
        ZWFSTU = "02";
      } 
      String ZOPDAT = log.getOpdate().replace("-", "");
      String ZOPTIM = log.getOptime().replace(":", "");
      String ZOPTYP = log.getOptype();
      String ZOPNAM = log.getOperatorid();
      String ZOPNAMT = resourceComInfo.getLastname(ZOPNAM);
      String ZOPDEP = resourceComInfo.getDepartmentID(ZOPNAM);
      ZOPDEP = departmentComInfo.getDepartmentname(ZOPDEP);
      String ZOPSIGN = log.getComment();
      if (ZOPSIGN.contains("remark") && ZOPSIGN.contains("remarkquote"))
        ZOPSIGN = ""; 
      String ismobile = getIsMobile(log.getId());
      if (ismobile.equals("g"))
        ZOPSIGN = "前一节点已审批，系统自动批准"; 
      ZOPSIGN = Util.delHtmlWithSpace(ZOPSIGN).replaceAll("&dt;", "").replaceAll("&at;", "");
      String str1 = "select receivedate,receivetime from workflow_currentoperator where requestid=" + requestInfo.getRequestid() + " and nodeid=" + ZNODID + " and userid=" + ZOPNAM;
      writeLog(str1);
      rs.execute(str1);
      rs.next();
      String str2 = Util.null2String(rs.getString(1)).replace("-", "");
      String str3 = Util.null2String(rs.getString(2)).replace(":", "");
      str1 = "select userid from workflow_currentoperator where nodeid in (select destnodeid from workflow_requestlog where requestid='" + requestInfo.getRequestid() + "' and nodeid='" + ZNODID + "') and requestid=" + requestInfo.getRequestid();
      writeLog(str1);
      rs.execute(str1);
      rs.next();
      String ZNXNAM = rs.getString(1);
      String ZNXNAMT = resourceComInfo.getLastname(ZNXNAM);
      REQUEST_LOG rEQUEST_LOG = new REQUEST_LOG();
      rEQUEST_LOG.setZNODID(ZNODID);
      rEQUEST_LOG.setZNODTX(ZNODTX);
      rEQUEST_LOG.setZWFSTU(ZWFSTU);
      rEQUEST_LOG.setZRVDAT(str2);
      rEQUEST_LOG.setZRVTIM(str3);
      rEQUEST_LOG.setZOPDAT(ZOPDAT);
      rEQUEST_LOG.setZOPTIM(ZOPTIM);
      rEQUEST_LOG.setZOPTYP(ZOPTYP);
      rEQUEST_LOG.setZOPDEP(ZOPDEP);
      rEQUEST_LOG.setZOPNAM(ZOPNAM);
      rEQUEST_LOG.setZOPNAMT(ZOPNAMT);
      rEQUEST_LOG.setZOPSIGN(ZOPSIGN);
      rEQUEST_LOG.setZNXNAM(ZNXNAM);
      rEQUEST_LOG.setZNXNAMT(ZNXNAMT);
      request_logs.add(rEQUEST_LOG);
    } 
    SimpleDateFormat sdf1 = new SimpleDateFormat("yyyyMMdd");
    SimpleDateFormat sdf2 = new SimpleDateFormat("HHmmss");
    Date date = new Date();
    REQUEST_LOG request_log = new REQUEST_LOG();
    request_log.setZNODID(requestManager.getNodeid() + "");
    request_log.setZNODTX(getNodeName(requestManager.getNodeid() + ""));
    request_log.setZWFSTU(status);
    String sql = "select receivedate,receivetime from workflow_currentoperator where requestid=" + requestInfo.getRequestid() + " and nodeid=" + requestManager.getNodeid() + " and userid=" + requestManager.getUserId();
    writeLog(sql);
    rs.execute(sql);
    rs.next();
    String ZRVDAT = Util.null2String(rs.getString(1)).replace("-", "");
    String ZRVTIM = Util.null2String(rs.getString(2)).replace(":", "");
    request_log.setZRVDAT(ZRVDAT);
    request_log.setZRVTIM(ZRVTIM);
    request_log.setZOPDAT(sdf1.format(date));
    request_log.setZOPTIM(sdf2.format(date));
    request_log.setZOPTYP(status);
    writeLog("depname:" + departmentComInfo.getDepartmentname(resourceComInfo.getDepartmentID(requestManager.getUserId() + "")));
    request_log.setZOPDEP(departmentComInfo.getDepartmentname(resourceComInfo.getDepartmentID(requestManager.getUserId() + "")));
    request_log.setZOPNAM(requestManager.getUserId() + "");
    request_log.setZOPNAMT(resourceComInfo.getLastname(requestManager.getUserId() + ""));
    request_log.setZOPSIGN(Util.delHtmlWithSpace(Util.null2String(remark)).replaceAll("&dt;", "").replaceAll("&at;", ""));
    request_log.setZNXNAM("");
    request_log.setZNXNAMT("");
    request_logs.add(request_log);
    writeLog("request_logs.toArray()");
    REQUEST_LOG[] request_logs1 = new REQUEST_LOG[request_logs.size()];
    for (int i = 0; i < request_logs.size(); i++)
      request_logs1[i] = request_logs.get(i); 
    req.setREQUEST_LOG(request_logs1);
    writeLog("new SubmitRequest()");
    SubmitRequest submitRequest = new SubmitRequest();
    String endpoint = getPropValue("yksap", "sapendpoint");
    String username = getPropValue("yksap", "sapusername");
    String password = getPropValue("yksap", "sappassword");
    writeLog(endpoint);
    writeLog(username);
    writeLog(password);
    return submitRequest.execute(req, endpoint, username, password);
  }
  
  private String getNodeName(String nodeid) {
    String sql = "select nodename from workflow_nodebase where id=" + nodeid;
    return getSqlValue(sql, 1);
  }
  
  private String getSqlValue(String sql, int index) {
    RecordSet rs = new RecordSet();
    rs.execute(sql);
    if (rs.next())
      return Util.null2String(rs.getString(index)); 
    return "";
  }
  
  private String getIsMobile(String logid) {
    RecordSet rs = new RecordSet();
    String sql = "select ismobile from workflow_requestlog where logid=" + logid;
    rs.execute(sql);
    rs.next();
    return Util.null2String(rs.getString(1));
  }
  
  public String getIFYWID() {
    return this.IFYWID;
  }
  
  public void setIFYWID(String IFYWID) {
    this.IFYWID = IFYWID;
  }
}
